
local Gamestate = require "source.library.gamestate"
local config    = require "config"
local GameScene = require "source.scene.GameScene"


local initializeWindow = function()
  local assets = require "source.Assets"
  love.graphics.setFont(assets.font)
  love.window.setTitle(config._title)
  love.window.setMode(config._resolutionX*config._scale, config._resolutionY*config._scale, {vsync=config._vsync})
end


function love.load()
  initializeWindow()
  Gamestate.registerEvents({"update", "keypressed"})
  Gamestate.switch(GameScene)
end


function love.draw()
  love.graphics.scale(config._scale, config._scale)
  GameScene:draw()
  love.graphics.print("FPS: "..love.timer.getFPS(), 10, 10)
  --love.graphics.print("Memory usage: "..math.floor(collectgarbage("count")).."KB", 60, 10)
  love.graphics.scale()
end

