

local config      = require "config"
local Signal      = require "source.library.signal"
local Actor       = require "source.actor.Actor"
local assets      = require "source.Assets"
local taxiLandingEvent, taxiStartingEvent
local Platform = Actor:extend()


function Platform:new(type, stationID, x, y)
  Platform.super.new(self, x, y)
  self.stationID = stationID or nil
  self:setType(type or "TaxiStation")
  self.sprite = assets.platform[self.type]
  self:setDimensions(64, 8)
  self.taxi = nil
  
  -- Signals
  taxiLandingEvent = function(taxi, station)
    if station == self then self.taxi = taxi end
  end
  taxiStartingEvent = function(taxi)
    if taxi == self.taxi then self.taxi = nil end
  end
  Signal.register("TaxiLanded", taxiLandingEvent)
  Signal.register("TaxiStarted", taxiStartingEvent)
end


function Platform:getStationID()
  if self.stationID then return self.stationID end
end


function Platform:draw()
  self:drawSprite(assets.spritesheet, self.sprite, self.x, self.y)
  --self:drawRectangle("line")
  if self.stationID then love.graphics.printf("Station "..self.stationID, self.x, self.y, self.width, "center")
  else love.graphics.printf("Fuel", self.x, self.y, self.width, "center") end
  --if self.taxi and self.stationID then love.graphics.print("Station: "..self.stationID..",  Taxi: "..tostring(self.taxi), 10, 100) end
end

return Platform
